package com.abelski.module;

import java.io.*;
import java.util.*;
import javax.security.auth.login.*;
import javax.security.auth.*;
import javax.security.auth.callback.*;

public class AuthenticationSample 
{
    public static void main(String[] args) 
	{
		LoginContext loginContext = null;
		try 
		{
			loginContext = new LoginContext("conf", new MyCallbackHandlerImplementation());
		} 
		catch (LoginException lex) 
		{
			lex.printStackTrace();
		} 
		catch (SecurityException se) 
		{
			se.printStackTrace();
		} 

		int tries;
		
		for (tries = 0; tries < 3; tries++) 
		{
			try 
			{
				loginContext.login();
				break;
			} 
			catch (LoginException le) 
			{
				le.printStackTrace();
			}
			try 
			{
				Thread.currentThread().sleep(4000);
			} 
			catch (Exception e) 
			{
				e.printStackTrace();
			} 
	    }

		if (tries == 3) 
		{
			System.out.println("Authentication Failed!");
			System.exit(-1);
		}

		System.out.println("Authentication Succeeded!");
    }
}



class MyCallbackHandlerImplementation implements CallbackHandler 
{
    public void handle(Callback[] callbacks)
		throws IOException, UnsupportedCallbackException 
	{
		for (int i = 0; i < callbacks.length; i++) 
		{
			if (callbacks[i] instanceof TextOutputCallback) 
			{
				TextOutputCallback call = (TextOutputCallback)callbacks[i];
				switch (call.getMessageType()) 
				{
					case TextOutputCallback.INFORMATION:
							System.out.println("information... " + call.getMessage());
							break;
					case TextOutputCallback.ERROR:
						    System.out.println("error... " + call.getMessage());
							break;
					case TextOutputCallback.WARNING:
							System.out.println("warning... " + call.getMessage());
							break;
					default:
						throw new IOException("unsupported message type... " +
							call.getMessageType());
				}
 			} 
			else if (callbacks[i] instanceof NameCallback) 
			{
				NameCallback call = (NameCallback)callbacks[i];
				System.err.print(call.getPrompt());
				System.err.flush();
				call.setName((new BufferedReader
				(new InputStreamReader(System.in))).readLine());
 			} 
			else if (callbacks[i] instanceof PasswordCallback) 
			{
				PasswordCallback call = (PasswordCallback)callbacks[i];
				System.err.print(call.getPrompt());
				System.err.flush();
				call.setPassword((new BufferedReader
				(new InputStreamReader(System.in))).readLine().toCharArray());
			} 
			else 
			{
				throw new UnsupportedCallbackException
					(callbacks[i], "unrecognized callback...");
			}
		}
    }
}

